﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Joseph Helm and Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Core.Views;
using HeuristicLab.MainForm;
using HeuristicLab.Problems.BinPacking.PackingItem;

namespace HeuristicLab.Problems.BinPacking.Views {
  [View("View for a rectangular packing item.")]
  [Content(typeof(RectangularPackingItem), true)]
  public partial class RectangularPackingItemView : NamedItemView {
    public RectangularPackingItemView() {
      InitializeComponent();
    }


    public new RectangularPackingItem Content {
      get { return (RectangularPackingItem)base.Content; }
      set { base.Content = value; }
    }


    protected override void OnContentChanged() {
      base.OnContentChanged();
      if (Content == null) {
        Redraw();
      } else {
        Redraw(Content);
      }
    }


    private void Redraw() {
      packingPlan2D.InitializeContainer(0,0);
    }

    private void Redraw(RectangularPackingItem item) {
      packingPlan2D.InitializeContainer(item.TargetBin.Width, item.TargetBin.Height);
      packingPlan2D.AddItemToContainer(item.Width, item.Height, 0, 0, "0");
    }

  }
}
